org.apache.commons.math3.analysis.differentiation

## Class FiniteDifferencesDifferentiator

- java.lang.Object
- - org.apache.commons.math3.analysis.differentiation.FiniteDifferencesDifferentiator

All Implemented Interfaces:
  Serializable, UnivariateFunctionDifferentiator, UnivariateMatrixFunctionDifferentiator, UnivariateVectorFunctionDifferentiator

    public class FiniteDifferencesDifferentiator
    extends Object
    implements UnivariateFunctionDifferentiator, UnivariateVectorFunctionDifferentiator, UnivariateMatrixFunctionDifferentiator, Serializable

Univariate functions differentiator using finite differences.

This class creates some wrapper objects around regular `univariate functions` (or `univariate vector functions` or `univariate matrix functions`). These wrapper objects compute derivatives in addition to function value.

The wrapper objects work by calling the underlying function on a sampling grid around the current point and performing polynomial interpolation. A finite differences scheme with n points is theoretically able to compute derivatives up to order n-1, but it is generally better to have a slight margin. The step size must also be small enough in order for the polynomial approximation to be good in the current point neighborhood, but it should not be too small because numerical instability appears quickly (there are several differences of close points). Choosing the number of points and the step size is highly problem dependent.

As an example of good and bad settings, lets consider the quintic polynomial function `f(x) = (x-1)*(x-0.5)*x*(x+0.5)*(x+1)`. Since it is a polynomial, finite differences with at least 6 points should theoretically recover the exact same polynomial and hence compute accurate derivatives for any order. However, due to numerical errors, we get the following results for a 7 points finite differences for abscissae in the [-10, 10] range:

- step size = 0.25, second order derivative error about 9.97e-10
- step size = 0.25, fourth order derivative error about 5.43e-8
- step size = 1.0e-6, second order derivative error about 148
- step size = 1.0e-6, fourth order derivative error about 6.35e+14

This example shows that the small step size is really bad, even simply for second order derivative!

Since:
  3.1
Version:
  $Id: FiniteDifferencesDifferentiator.java 1420666 2012-12-12 13:33:20Z erans $
See Also:
  Serialized Form

### Field Summary

Fields
`private double` `halfSampleSpan` Half sample span.
`private int` `nbPoints` Number of points to use.
`private static long` `serialVersionUID` Serializable UID.
`private double` `stepSize` Step size.
`private double` `tMax` Upper bound for independent variable.
`private double` `tMin` Lower bound for independent variable.

### Constructor Summary

Constructors
Constructor and Description
`FiniteDifferencesDifferentiator(int nbPoints, double stepSize)` Build a differentiator with number of points and step size when independent variable is unbounded.
`FiniteDifferencesDifferentiator(int nbPoints, double stepSize, double tLower, double tUpper)` Build a differentiator with number of points and step size when independent variable is bounded.

### Method Summary

Methods
`UnivariateDifferentiableFunction` `differentiate(UnivariateFunction function)` Create an implementation of a `differential` from a regular `function`.
`UnivariateDifferentiableMatrixFunction` `differentiate(UnivariateMatrixFunction function)` Create an implementation of a `differential` from a regular `matrix function`.
`UnivariateDifferentiableVectorFunction` `differentiate(UnivariateVectorFunction function)` Create an implementation of a `differential` from a regular `vector function`.
`private DerivativeStructure` `evaluate(DerivativeStructure t, double t0, double[] y)` Evaluate derivatives from a sample.
`int` `getNbPoints()` Get the number of points to use.
`double` `getStepSize()` Get the step size.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serializable UID.

See Also:
  Constant Field Values

#### nbPoints

    private final int nbPoints

Number of points to use.

#### stepSize

    private final double stepSize

Step size.

#### halfSampleSpan

    private final double halfSampleSpan

Half sample span.

#### tMin

    private final double tMin

Lower bound for independent variable.

#### tMax

    private final double tMax

Upper bound for independent variable.

### Constructor Detail

#### FiniteDifferencesDifferentiator

    public FiniteDifferencesDifferentiator(int nbPoints,
                                   double stepSize)
                                    throws NotPositiveException,
                                           NumberIsTooSmallException

Build a differentiator with number of points and step size when independent variable is unbounded.

Beware that wrong settings for the finite differences differentiator can lead to highly unstable and inaccurate results, especially for high derivation orders. Using very small step sizes is often a bad idea.

Parameters:
  `nbPoints` - number of points to use
  `stepSize` - step size (gap between each point)
Throws:
  `NotPositiveException` - if `stepsize <= 0` (note that `NotPositiveException` extends `NumberIsTooSmallException`)
  `NumberIsTooSmallException` - `nbPoint <= 1`

#### FiniteDifferencesDifferentiator

    public FiniteDifferencesDifferentiator(int nbPoints,
                                   double stepSize,
                                   double tLower,
                                   double tUpper)
                                    throws NotPositiveException,
                                           NumberIsTooSmallException,
                                           NumberIsTooLargeException

Build a differentiator with number of points and step size when independent variable is bounded.

When the independent variable is bounded (tLower < t < tUpper), the sampling points used for differentiation will be adapted to ensure the constraint holds even near the boundaries. This means the sample will not be centered anymore in these cases. At an extreme case, computing derivatives exactly at the lower bound will lead the sample to be entirely on the right side of the derivation point.

Note that the boundaries are considered to be excluded for function evaluation.

Beware that wrong settings for the finite differences differentiator can lead to highly unstable and inaccurate results, especially for high derivation orders. Using very small step sizes is often a bad idea.

Parameters:
  `nbPoints` - number of points to use
  `stepSize` - step size (gap between each point)
  `tLower` - lower bound for independent variable (may be `Double.NEGATIVE_INFINITY` if there are no lower bounds)
  `tUpper` - upper bound for independent variable (may be `Double.POSITIVE_INFINITY` if there are no upper bounds)
Throws:
  `NotPositiveException` - if `stepsize <= 0` (note that `NotPositiveException` extends `NumberIsTooSmallException`)
  `NumberIsTooSmallException` - `nbPoint <= 1`
  `NumberIsTooLargeException` - `stepSize * (nbPoints - 1) >= tUpper - tLower`

### Method Detail

#### getNbPoints

    public int getNbPoints()

Get the number of points to use.

Returns:
  number of points to use

#### getStepSize

    public double getStepSize()

Get the step size.

Returns:
  step size

#### evaluate

    private DerivativeStructure evaluate(DerivativeStructure t,
                               double t0,
                               double[] y)
                                  throws NumberIsTooLargeException

Evaluate derivatives from a sample.

Evaluation is done using divided differences.

Parameters:
  `t` - evaluation abscissa value and derivatives
  `t0` - first sample point abscissa
  `y` - function values sample `y[i] = f(t[i]) = f(t0 + i * stepSize)`
Returns:
  value and derivatives at `t`
Throws:
  `NumberIsTooLargeException` - if the requested derivation order is larger or equal to the number of points

#### differentiate

    public UnivariateDifferentiableFunction differentiate(UnivariateFunction function)

Create an implementation of a `differential` from a regular `function`.

The returned object cannot compute derivatives to arbitrary orders. The value function will throw a `NumberIsTooLargeException` if the requested derivation order is larger or equal to the number of points.

Specified by:
  `differentiate` in interface `UnivariateFunctionDifferentiator`
Parameters:
  `function` - function to differentiate
Returns:
  differential function

#### differentiate

    public UnivariateDifferentiableVectorFunction differentiate(UnivariateVectorFunction function)

Create an implementation of a `differential` from a regular `vector function`.

The returned object cannot compute derivatives to arbitrary orders. The value function will throw a `NumberIsTooLargeException` if the requested derivation order is larger or equal to the number of points.

Specified by:
  `differentiate` in interface `UnivariateVectorFunctionDifferentiator`
Parameters:
  `function` - function to differentiate
Returns:
  differential function

#### differentiate

    public UnivariateDifferentiableMatrixFunction differentiate(UnivariateMatrixFunction function)

Create an implementation of a `differential` from a regular `matrix function`.

The returned object cannot compute derivatives to arbitrary orders. The value function will throw a `NumberIsTooLargeException` if the requested derivation order is larger or equal to the number of points.

Specified by:
  `differentiate` in interface `UnivariateMatrixFunctionDifferentiator`
Parameters:
  `function` - function to differentiate
Returns:
  differential function